/*
  OpenMW - The completely unofficial reimplementation of Morrowind
  Copyright (C) 2008-2010  Nicolay Korslund
  Email: < korslund@gmail.com >
  WWW: http://openmw.sourceforge.net/

  This file (nif_types.h) is part of the OpenMW package.

  OpenMW is distributed as free software: you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  version 3, as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  version 3 along with this program. If not, see
  http://www.gnu.org/licenses/ .

 */

#ifndef _NIF_TYPES_H_
#define _NIF_TYPES_H_

#include <OgreVector3.h>
#include <OgreMatrix3.h>

// Common types used in NIF files

namespace Nif
{

struct Transformation
{
    Ogre::Vector3 pos;
    Ogre::Matrix3 rotation;
    float scale;
    Ogre::Vector3 velocity;

    static const Transformation& getIdentity()
    {
        static Transformation identity;
        static bool iset = false;
        if (!iset)
        {
            identity.scale = 1.0f;
            identity.rotation[0][0] = 1.0f;
            identity.rotation[1][1] = 1.0f;
            identity.rotation[2][2] = 1.0f;
            iset = true;
        }

        return identity;
    }
};

} // Namespace
#endif
